package com.hwrj.cloud.portal.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UmsMemberOriginProductExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UmsMemberOriginProductExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdIsNull() {
            addCriterion("fk_origin_id is null");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdIsNotNull() {
            addCriterion("fk_origin_id is not null");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdEqualTo(Long value) {
            addCriterion("fk_origin_id =", value, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdNotEqualTo(Long value) {
            addCriterion("fk_origin_id <>", value, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdGreaterThan(Long value) {
            addCriterion("fk_origin_id >", value, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdGreaterThanOrEqualTo(Long value) {
            addCriterion("fk_origin_id >=", value, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdLessThan(Long value) {
            addCriterion("fk_origin_id <", value, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdLessThanOrEqualTo(Long value) {
            addCriterion("fk_origin_id <=", value, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdIn(List<Long> values) {
            addCriterion("fk_origin_id in", values, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdNotIn(List<Long> values) {
            addCriterion("fk_origin_id not in", values, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdBetween(Long value1, Long value2) {
            addCriterion("fk_origin_id between", value1, value2, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andFkOriginIdNotBetween(Long value1, Long value2) {
            addCriterion("fk_origin_id not between", value1, value2, "fkOriginId");
            return (Criteria) this;
        }

        public Criteria andProductNameIsNull() {
            addCriterion("product_name is null");
            return (Criteria) this;
        }

        public Criteria andProductNameIsNotNull() {
            addCriterion("product_name is not null");
            return (Criteria) this;
        }

        public Criteria andProductNameEqualTo(String value) {
            addCriterion("product_name =", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotEqualTo(String value) {
            addCriterion("product_name <>", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameGreaterThan(String value) {
            addCriterion("product_name >", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameGreaterThanOrEqualTo(String value) {
            addCriterion("product_name >=", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameLessThan(String value) {
            addCriterion("product_name <", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameLessThanOrEqualTo(String value) {
            addCriterion("product_name <=", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameLike(String value) {
            addCriterion("product_name like", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotLike(String value) {
            addCriterion("product_name not like", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameIn(List<String> values) {
            addCriterion("product_name in", values, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotIn(List<String> values) {
            addCriterion("product_name not in", values, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameBetween(String value1, String value2) {
            addCriterion("product_name between", value1, value2, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotBetween(String value1, String value2) {
            addCriterion("product_name not between", value1, value2, "productName");
            return (Criteria) this;
        }

        public Criteria andPlantAreaIsNull() {
            addCriterion("plant_area is null");
            return (Criteria) this;
        }

        public Criteria andPlantAreaIsNotNull() {
            addCriterion("plant_area is not null");
            return (Criteria) this;
        }

        public Criteria andPlantAreaEqualTo(String value) {
            addCriterion("plant_area =", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaNotEqualTo(String value) {
            addCriterion("plant_area <>", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaGreaterThan(String value) {
            addCriterion("plant_area >", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaGreaterThanOrEqualTo(String value) {
            addCriterion("plant_area >=", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaLessThan(String value) {
            addCriterion("plant_area <", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaLessThanOrEqualTo(String value) {
            addCriterion("plant_area <=", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaLike(String value) {
            addCriterion("plant_area like", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaNotLike(String value) {
            addCriterion("plant_area not like", value, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaIn(List<String> values) {
            addCriterion("plant_area in", values, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaNotIn(List<String> values) {
            addCriterion("plant_area not in", values, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaBetween(String value1, String value2) {
            addCriterion("plant_area between", value1, value2, "plantArea");
            return (Criteria) this;
        }

        public Criteria andPlantAreaNotBetween(String value1, String value2) {
            addCriterion("plant_area not between", value1, value2, "plantArea");
            return (Criteria) this;
        }

        public Criteria andOutputNumIsNull() {
            addCriterion("output_num is null");
            return (Criteria) this;
        }

        public Criteria andOutputNumIsNotNull() {
            addCriterion("output_num is not null");
            return (Criteria) this;
        }

        public Criteria andOutputNumEqualTo(String value) {
            addCriterion("output_num =", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumNotEqualTo(String value) {
            addCriterion("output_num <>", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumGreaterThan(String value) {
            addCriterion("output_num >", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumGreaterThanOrEqualTo(String value) {
            addCriterion("output_num >=", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumLessThan(String value) {
            addCriterion("output_num <", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumLessThanOrEqualTo(String value) {
            addCriterion("output_num <=", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumLike(String value) {
            addCriterion("output_num like", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumNotLike(String value) {
            addCriterion("output_num not like", value, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumIn(List<String> values) {
            addCriterion("output_num in", values, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumNotIn(List<String> values) {
            addCriterion("output_num not in", values, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumBetween(String value1, String value2) {
            addCriterion("output_num between", value1, value2, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputNumNotBetween(String value1, String value2) {
            addCriterion("output_num not between", value1, value2, "outputNum");
            return (Criteria) this;
        }

        public Criteria andOutputValueIsNull() {
            addCriterion("output_value is null");
            return (Criteria) this;
        }

        public Criteria andOutputValueIsNotNull() {
            addCriterion("output_value is not null");
            return (Criteria) this;
        }

        public Criteria andOutputValueEqualTo(String value) {
            addCriterion("output_value =", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueNotEqualTo(String value) {
            addCriterion("output_value <>", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueGreaterThan(String value) {
            addCriterion("output_value >", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueGreaterThanOrEqualTo(String value) {
            addCriterion("output_value >=", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueLessThan(String value) {
            addCriterion("output_value <", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueLessThanOrEqualTo(String value) {
            addCriterion("output_value <=", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueLike(String value) {
            addCriterion("output_value like", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueNotLike(String value) {
            addCriterion("output_value not like", value, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueIn(List<String> values) {
            addCriterion("output_value in", values, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueNotIn(List<String> values) {
            addCriterion("output_value not in", values, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueBetween(String value1, String value2) {
            addCriterion("output_value between", value1, value2, "outputValue");
            return (Criteria) this;
        }

        public Criteria andOutputValueNotBetween(String value1, String value2) {
            addCriterion("output_value not between", value1, value2, "outputValue");
            return (Criteria) this;
        }

        public Criteria andStateIsNull() {
            addCriterion("state is null");
            return (Criteria) this;
        }

        public Criteria andStateIsNotNull() {
            addCriterion("state is not null");
            return (Criteria) this;
        }

        public Criteria andStateEqualTo(Integer value) {
            addCriterion("state =", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateNotEqualTo(Integer value) {
            addCriterion("state <>", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateGreaterThan(Integer value) {
            addCriterion("state >", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateGreaterThanOrEqualTo(Integer value) {
            addCriterion("state >=", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateLessThan(Integer value) {
            addCriterion("state <", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateLessThanOrEqualTo(Integer value) {
            addCriterion("state <=", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateIn(List<Integer> values) {
            addCriterion("state in", values, "state");
            return (Criteria) this;
        }

        public Criteria andStateNotIn(List<Integer> values) {
            addCriterion("state not in", values, "state");
            return (Criteria) this;
        }

        public Criteria andStateBetween(Integer value1, Integer value2) {
            addCriterion("state between", value1, value2, "state");
            return (Criteria) this;
        }

        public Criteria andStateNotBetween(Integer value1, Integer value2) {
            addCriterion("state not between", value1, value2, "state");
            return (Criteria) this;
        }

        public Criteria andCreateIdIsNull() {
            addCriterion("create_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateIdIsNotNull() {
            addCriterion("create_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateIdEqualTo(Integer value) {
            addCriterion("create_id =", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdNotEqualTo(Integer value) {
            addCriterion("create_id <>", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdGreaterThan(Integer value) {
            addCriterion("create_id >", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("create_id >=", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdLessThan(Integer value) {
            addCriterion("create_id <", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdLessThanOrEqualTo(Integer value) {
            addCriterion("create_id <=", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdIn(List<Integer> values) {
            addCriterion("create_id in", values, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdNotIn(List<Integer> values) {
            addCriterion("create_id not in", values, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdBetween(Integer value1, Integer value2) {
            addCriterion("create_id between", value1, value2, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdNotBetween(Integer value1, Integer value2) {
            addCriterion("create_id not between", value1, value2, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateIdIsNull() {
            addCriterion("update_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateIdIsNotNull() {
            addCriterion("update_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateIdEqualTo(Integer value) {
            addCriterion("update_id =", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdNotEqualTo(Integer value) {
            addCriterion("update_id <>", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdGreaterThan(Integer value) {
            addCriterion("update_id >", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("update_id >=", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdLessThan(Integer value) {
            addCriterion("update_id <", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdLessThanOrEqualTo(Integer value) {
            addCriterion("update_id <=", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdIn(List<Integer> values) {
            addCriterion("update_id in", values, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdNotIn(List<Integer> values) {
            addCriterion("update_id not in", values, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdBetween(Integer value1, Integer value2) {
            addCriterion("update_id between", value1, value2, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdNotBetween(Integer value1, Integer value2) {
            addCriterion("update_id not between", value1, value2, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}